SystemOrganization addCategory: #TADP!

Object subclass: #Natural
	instanceVariableNames: 'valor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP'!

!Natural methodsFor: 'accessing' stamp: 'Edu 3/24/2013 19:59'!
divisiblePor: unNumero 
	^((self valor \\ unNumero) == 0)
! !

!Natural methodsFor: 'accessing' stamp: 'Edu 3/24/2013 20:10'!
divisores
	|divisores|
	divisores := Bag new.
	1 to: self valor do: [:unPosibleDivisor |
		 (self divisiblePor: unPosibleDivisor) ifTrue: [divisores add: unPosibleDivisor].
	].
	^divisores.! !

!Natural methodsFor: 'accessing' stamp: 'Edu 3/24/2013 20:20'!
esPerfecto
	^self valor == self sumatoriaDeDivisores! !

!Natural methodsFor: 'accessing' stamp: 'Edu 3/24/2013 20:12'!
esPrimo
	^(self divisores size == 2)! !

!Natural methodsFor: 'accessing' stamp: 'Edu 3/24/2013 20:35'!
primerosPerfectos
	|unNatural primerosPerfectos|
	unNatural := Natural new.
	primerosPerfectos  := Bag new.
	
	1 to: self valor do: [ :i | 
		unNatural valor: i.
		(unNatural esPerfecto) ifTrue: [primerosPerfectos add: i]	
	].
	^primerosPerfectos.! !

!Natural methodsFor: 'accessing' stamp: 'Edu 3/24/2013 20:24'!
sumatoriaDeDivisores
	^ (self divisores inject: 0 into: [ :suma :unDivisor |  suma + unDivisor]) - self valor 
! !

!Natural methodsFor: 'accessing' stamp: 'Edu 3/24/2013 19:52'!
valor
	^ valor! !

!Natural methodsFor: 'accessing' stamp: 'Edu 3/24/2013 19:52'!
valor: anObject
	valor := anObject! !
